#<profile4xi profile = "12" /> 
# =================================================================================================
#<program4xi program = "mpu2buffer4xi.py">
#<abstract4xi abstract = "MPU buffer management"/>
#<refer4xi reference = "buffer4xi.py"/>
#<verify4xi verification = "10" target = "mpu3image4xi.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MPU2Buffer4Xi',  
            'create2buffer4mpu',
            'create2subbuffer4mpu',
            'get2bufferinfo4mpu',
            'release2buffer4mpu',
            'retain2buffer4mpu',
            'set2buffer4mpu',
            'trace2buffer4mpu'] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   

from decimal import *
from ctypes import Structure, c_double
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from mpu2context4xi import get2context4mpu
from mpu2device4xi import get2mpu4xi
from platformids4xi  import get2platformids4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from print4xi import print4xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                             
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global mpu2buffer4xi                                                    # Buffer of MPU 
global mpu2subbuffer4xi                                                 # Sub-buffer of MPU 
global mpu2trace4xi                                                     # TRACE

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2buffer4mpu" usage = "
#
#  task4create2mpu = {}                                                                                            
#  task4create2mpu= {}      
#  task4create2mpu['FUNCTION2CALLBACK'] = trace2buffer4mpu                                                                 # CALLBACK FUNCTION CALLED BY MPUIZED OPENCL
#
#  args2callback = {}                                                                                                           
#  args2callback['CLASS']   = "create2buffer4mpu"                                                                             # MODULE OF MPUIZED OPENCL MODULE
#  args2callback['METHOD']  = "create2buffer4mpu"                                                                             # FUNCTION OF MPUIZED OPENCL MODULE
#  args2callback['MESSAGE'] = "{(Step 2Z1/33) failed" + "; create2buffer4mpu-failed " + "; time: " + time4xi() + "}"          # ERROR MESSAGE FOR MPUIZED OPENCL TO RETURN    
#  
#  task4create2mpu['ARGS2CALLBACK'] = args2callback                                                                           # MAX ONE ARG - THEREFORE GIVE SEVERAL ARGS IN ONE DICTIONARY 
#  
#  response4create2buffer = {}
#  print('(Step 1A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO CREATE BUFFER FOR MPU ', time4xi())  
#  try:                               
#      response4create2buffer = create2buffer4mpu (task4create2mpu)                                                        # EXAMINE RESPONSE!                                                      
#      print('(Step 1B/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4CREATE2BUFFER: ', response4create2buffer)                          # trace2buffer4mpu CALLED BY MPUIZED OPENCL IN EXCEPTIONS - CHECK MPUIZED TRACE!                       
#  except: 
#      print('(Step Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO CREARE BUFFER FOR MPU ', time4xi())  
#
#">

# -------------------------------------------------------------------------------------------------   
def trace2buffer4mpu(task4trace2mpu=None):

    '''
    trace for mpu2buffer4xi
    '''
    
    global mpu2trace4xi 
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2buffer4mpu" 
    method2print = "trace2buffer4mpu"

    message2print = "{(Step 1A/33) started" + "; trace2buffer4mpu-started: " + str(trace2buffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2mpu-to-trace2buffer4mpu: " + str(task4trace2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                                 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    mpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2mpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY MPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2mpu = {}                                                                                            
            
        task4trace2mpu= {} 
  
        message2print = "{(Step 2A/33) warned" + "; task4trace2mpu-warned-by-trace2buffer4mpu to: " + str(task4trace2mpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
            
        code2nack = code2nack + '2A-'            

    else:
        # -----------------------------------------------------------------------------------------
        # PARAMETER GIVEN BY MPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------          
        message2print = "{(Step 3A/33) try" + "; task4trace2mpu-try-by-trace2buffer4mpu: " + str(task4trace2mpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 

        try:
            class2print   = task4trace2mpu['CLASS']                                                               # MPUIZE MPU TRACE!
            method2print  = task4trace2mpu['METHOD']
            message2print = task4trace2mpu['MESSAGE']
            print4xi(class2print, method2print, message2print)                                                       # MPUIZED TRACE FOR OPENCL CALLBACK!
            # =================================
            # 
            # =================================
            
            class2print = "trace2buffer4mpu"                                                                      # SET TRACE BACK TO THIS FUNCTION!
            method2print = "trace2buffer4mpu"                
            message2print = "{(Step 3B/33) performed" + "; mpu-trace-performed-by-trace2buffer4mpu: " + str(task4trace2mpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 

            code2ack = code2ack + '3B-' 
        except:
            message2print = "{(Step 3Z1/33) failed" + "; mpu-trace-failed-by-trace2buffer4mpu: " + str(task4trace2mpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            code2nack = code2nack + '3Z1-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; trace2buffer4mpu-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    # 
    
    return
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2buffer4mpu" usage = "
#     
#   buffer4xi = {}        
#   try:
#       buffer4xi['MPU'] = create2buffer4mpu()                                                              # MPU buffer      
#       message2print = "{(Step 2B/33) initialized" + "; mpu-buffer4xi-initialized-by-create2buffer4xi to: " + str(buffer4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # buffer of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; buffer4xi-yielded-by-create2buffer4xi: " + str(buffer4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2buffer4mpu(task4create2mpu=None):

    '''
    creates mpu2buffer4xi
    '''
    
    global mpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2buffer4mpu" 
    method2print = "create2buffer4mpu"

    message2print = "{(Step 1A/70) started" + "; create2buffer4mpu-started: " + str(create2buffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2buffer4mpu at 0x00000000037ADF48> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2mpu-to-create2buffer4mpu: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # None

    code2ack  = ' '
    code2nack = ' '    
    
    mpu2buffer4xi = {}                                                                                        # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2mpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO MPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4create2mpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2mpu-initialized-by-create2buffer4mpu to: " + str(task4create2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4mpu = trace2buffer4mpu                                                        # CALLBACK FUNCTION FOR MPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4mpu-initialized-by-create2buffer4mpu to: " + str(function2callback4mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2buffer4mpu at 0x00000000037B5B48>
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                   # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2buffer4mpu"                                                    # MODULE OF MPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2buffer4mpu"                                                    # FUNCTION OF MPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2buffer4mpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR MPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2buffer4mpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4mpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2buffer4mpu', 'METHOD': 'create2buffer4mpu'}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACK - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu['DATA2CALLBACK'] = args2callback                                                   # USER DATA PASSED TO MPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2mpu['FUNCTION2CALLBACK'] = function2callback4mpu                                    # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2mpu-initialized-by-create2buffer4mpu to: " + str(task4create2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2buffer4mpu at 0x00000000037B5B48>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4mpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
            #  'CLASS': 'create2buffer4mpu', 'METHOD': 'create2buffer4mpu'}}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-initialized-by-create2buffer4mpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2buffer4mpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 02:07:07 05/23/11 Pacific Daylight Time}
    
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2buffer4mpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4create2mpu['PLATFORM'] = platform2xi                                                            # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            context2mpu = None
            message2print = "{(Step 3A/70) trying" + "; context2mpu-trying-by-create2buffer4mpu: " + str(context2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2mpu = get2context4mpu()                                                               # NO PARAMETERS - THE SYSTEM CREATES   
                
                message2print = "{(Step 3B/70) got" + "; context2mpu-got-by-create2buffer4mpu: " + str(context2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 02:07:07 05/23/11 Pacific Daylight Time}', 
                #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000037A5448>, 
                #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
                #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
                #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2mpu-failed-by-create2buffer4mpu: " + str(context2mpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
            task4create2mpu ['CONTEXT'] = context2mpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                           
            # ---------------------------------------------------------------------------------------------    
            device2mpu = None
            message2print = "{(Step 4A/70) trying" + "; device2mpu-trying-by-create2buffer4mpu: " + str(device2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2mpu = get2mpu4xi()                                                                     # NO PARAMETERS - THE SYSTEM CREATES    
                
                message2print = "{(Step 4B/70) got" + "; device2mpu-got-by-create2buffer4mpu: " + str(device2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 
                #  'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
                #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4,
                #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
                #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
                #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
                #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64,
                #  'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK',
                #  'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
                #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
                #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033,
                #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
                #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16,
                #  'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
                #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
                #  'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_MPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}; time: 02:07:07 05/23/11 Pacific Daylight Time}
 
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2mpu-failed-by-create2buffer4mpu: " + str(device2mpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4create2mpu ['DEVICE'] = device2mpu
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE FLAGS - REQUIRED                           
            # ---------------------------------------------------------------------------------------------         
            task4create2mpu ['FLAGS'] = 0b00000000000000000000000000000000
            message2print = "{(Step 6A/70) initialized" + "; flags-initialized-by-create2buffer4mpu to: " + str(task4create2mpu ['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '6A-'         
        
            # ---------------------------------------------------------------------------------------------
            # (7) DEFINE SIZE OF MEMORY OBJECT - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4create2mpu ['SIZE'] = 8192*34
            message2print = "{(Step 7A/70) initialized" + "; size2buffer-initialized-by-create2buffer4mpu to: " + str(task4create2mpu ['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 278528
            
            code2ack  = code2ack + '7A-'
            
            # -----------------------------------------------------------------------------------------
            # (8) ARENA TO MPU - REQUIRED 
            # ----------------------------------------------------------------------------------------- 
            arena2mpu = None
            message2print = "{(Step 8A/70) try" + "; size2buffer-try-by-create2buffer4mpu: " + str(task4create2mpu ['SIZE']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            try:
                arena2mpu = Arena4Xi(task4create2mpu ['SIZE'])
                message2print = "{(Step 8B1/70) created" + "; arena2mpu-initialized-by-create2buffer4mpu to: " + str(arena2mpu)  + "; time: " + time4xi() + "}"   
                print4xi(class2print, method2print, message2print)
                # <arena4xi.Arena4Xi object at 0x0000000003AB9E48>   
                
                size2mpu = None
                try:
                    size2mpu = arena2mpu.size                                                                       # 
                
                    message2print = "{(Step 8B2/70) got" + "; size2mpu-got-by-create2buffer4mpu: " + str(size2mpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 278528  
                    
                    name2mpu = arena2mpu.name                                                                       # 
                
                    message2print = "{(Step 8B3/70) got" + "; name2mpu-got-by-create2buffer4mpu: " + str(name2mpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # pym-2204-0                     

                except:
                    message2print = "{(Step 8Z1/70) failed" + "; size2mpu-failed-by-create2buffer4mpu: " + str(size2mpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    
                code2ack  = code2ack + '8A-'             
            except:
                task4create2mpu ['SIZE'] = int(task4create2mpu ['SIZE']/8)                                    # RE-ADJUST AND TRY GET LESS MEMORY
                
                message2print = "{(Step 8C/70) set" + "; size2buffer-set-by-create2buffer4mpu to: " + str(task4create2mpu ['SIZE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                try:
                    arena2mpu = Arena4Xi(task4create2mpu ['SIZE'])
                    message2print = "{(Step 8D/70) created" + "; arena2mpu-initialized-by-create2buffer4mpu to: " + str(arena2mpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                
                    code2ack  = code2ack + '8D-'
                                          
                except:
                    message2print = "{(Step 8Z270) failed" + "; arena2mpu-failed-by-create2buffer4mpu: " + str(arena2mpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    code2nack  = code2nack + '8Z-' 
                   
            task4create2mpu ['POINTER2BUFFER'] = arena2mpu.buffer       
            
            message2print = "{(Step 8E/70) set" + "; buffer-set-by-create2buffer4mpu to: " + str(task4create2mpu ['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <mmap.mmap object at 0x0000000004341088>; time: 23:27:47 09/01/11 Pacific Daylight Time}  
            
            code2ack  = code2ack + '8E-'
                            
            # ---------------------------------------------------------------------------------------------
            # (9) ERROR CODE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['CODE2ERROR'] = 0                                                                   # 
              
            message2print = "{(Step 9A/70) created" + "; code2error-initialized-by-create2buffer4mpu to: " + str(task4create2mpu ['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '9A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (10) REFERENCE COUNT - REQUIRED FOR RETAIN(ATTACH) AND RELEASE                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['COUNT2REFERENCE'] = 0                                                              # USED TO RETAIN(ATTACH) AND RELEASE BUFFER
              
            message2print = "{(Step 10A/70) created" + "; count2reference-initialized-by-create2buffer4mpu to: " + str(task4create2mpu ['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '10A-'
            
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2mpu-yielded-by-create2buffer4mpu: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        code2nack  = code2nack + '1Z1-' 

    mpu2buffer4xi = {}                                                                                           # INITIALIZE MPU BUFFER                                                                                     

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2mpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2buffer4mpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'DATA2CALLBACK' in keys2task:
                                                                                                                    # CREATE! 
        message2print = "{(Step 11A/70) try" + "; data2callback-try-by-create2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 11/70) - DATA2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['DATA2CALLBACK'] = task4create2mpu['DATA2CALLBACK']
            
            message2print = "{(Step 11B/70) initialized" + "; data2callback-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4mpu-failed ; time: 05:25:33 05/23/11 Pacific Daylight Time}',
            #  'CLASS': 'create2buffer4mpu', 'METHOD': 'create2buffer4mpu'}; time: 05:25:33 05/23/11 Pacific Daylight Time}
     
            code2ack  = code2ack + '11B-'
        except: 
            message2print = "{(Step 11Z1/70) yielded" + "; data2callback-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '11Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 12A/70) try" + "; function2callback-try-by-create2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 12/70) - FUNCTION2CALLBACK - EXTRA
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['FUNCTION2CALLBACK'] = task4create2mpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 12B/70) initialized" + "; function2callback-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2buffer4mpu at 0x0000000003770B48>
             
            code2ack  = code2ack + '12B-'
        except: 
            message2print = "{(Step 12Z1/70) yielded" + "; function2callback-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '12Z1-' 
               

    if 'CONTEXT' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 13/70) - CONTEXT - REQUIRED
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['CONTEXT'] = task4create2mpu['CONTEXT']
            
            message2print = "{(Step 13B/70) initialized" + "; context-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 05:25:33 05/23/11 Pacific Daylight Time}',
            #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x0000000003760448>,
            #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
            #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
            #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}; time: 05:25:33 05/23/11 Pacific Daylight Time}
    
            code2ack  = code2ack + '13B-'
        except: 
            message2print = "{(Step 13Z1/70) yielded" + "; context-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '13Z1-' 

    if 'DEVICE' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 14/70) - DEVICE - EXTRA
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['DEVICE'] = task4create2mpu['DEVICE']
            
            message2print = "{(Step 14B/70) initialized" + "; device-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
            #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4,
            #  'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
            #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
            #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
            #  'VERSION2DRIVER': '2.0',
            #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
            #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
            #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
            #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
            #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
            #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
            #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
            #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
            #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
            #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
            #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
            #  'TYPE': 'CL_DEVICE_TYPE_MPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}; time: 05:25:33 05/23/11 Pacific Daylight Time}
     
            code2ack  = code2ack + '14B-'
        except: 
            message2print = "{(Step 14Z1/70) yielded" + "; device-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '14Z1-'         

    if 'FLAGS' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 15/70) - FLAGS - REQUIRED
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['FLAGS'] = task4create2mpu ['FLAGS'] 
            
            message2print = "{(Step 15B/70) initialized" + "; flags-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0 
            
            code2ack  = code2ack + '15B-'
        except: 
            message2print = "{(Step 15Z1/70) yielded" + "; flags-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '15Z1-'     


    if 'SIZE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 16/70) - SIZE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['SIZE'] = task4create2mpu ['SIZE'] 
            
            message2print = "{(Step 16B/70) initialized" + "; size-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 278528
            code2ack  = code2ack + '16B-'
        except: 
            message2print = "{(Step 16Z1/70) yielded" + "; size-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '16Z1-'             

    if 'POINTER2BUFFER' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 17/70) - POINTER2BUFFER - REQUIRED
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['POINTER2BUFFER'] = task4create2mpu ['POINTER2BUFFER'] 
            
            message2print = "{(Step 17B/70) initialized" + "; pointer2buffer-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '17B-'
        except: 
            message2print = "{(Step 17Z1/70) yielded" + "; pointer2buffer-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '17Z1-'    

    if 'CODE2ERROR' in keys2task:             
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 18/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['CODE2ERROR'] = task4create2mpu['CODE2ERROR']
            
            message2print = "{(Step 18B/70) initialized" + "; code2error-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            code2ack  = code2ack + '18B-'
        except: 
            message2print = "{(Step 18Z1/70) yielded" + "; code2error-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '18Z1-'                

    if 'COUNT2REFERENCE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 19/70) - REFERENCE COUNT - MUST FOR MANAGEMENT
            # -----------------------------------------------------------------------------------------               
            mpu2buffer4xi['COUNT2REFERENCE'] = task4create2mpu['COUNT2REFERENCE']
            
            message2print = "{(Step 19B/70) initialized" + "; reference-initialized-by-create2buffer4mpu to: " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0 
            code2ack  = code2ack + '19B-'
        except: 
            message2print = "{(Step 19Z1/70) yielded" + "; reference-mpu2buffer4xi-yielded-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '19Z1-'                     
            

                                                 
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    mpu2buffer4xi ['ACK2RETURN']  = code2ack
    mpu2buffer4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; mpu2buffer4xi-returning-by-create2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4mpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2buffer4mpu',
    #  'METHOD': 'create2buffer4mpu'},
    #  'FUNCTION2CALLBACK': <function trace2buffer4mpu at 0x00000000039E32C8>,
    #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000042EA088>,
    #  'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
    #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
    #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4,
    #  'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536,
    #  'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
    #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8,
    #  'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768,
    #  'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4,
    #  'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033,
    #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
    #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16,
    #  'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)',
    #  'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
    #  'TYPE': 'CL_DEVICE_TYPE_MPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}; time: 00:14:43 09/02/11 Pacific Daylight Time}


    return mpu2buffer4xi
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2subbuffer4mpu" usage = "
#     
#   subbuffer4xi = {}        
#   try:
#       subbuffer4xi['MPU'] = create2subbuffer4mpu()                                                        # MPU subbuffer      
#       message2print = "{(Step 2B/33) initialized" + "; mpu-subbuffer4xi-initialized-by-create2subbuffer4xi to: " + str(subbuffer4xi)  + "; time: " + time4xi() + "}" 
#       print4xi(class2print, method2print, message2print)     
#       ....                                                                                                      # subbuffer of devices
#   except:
#       message2print = "{(Step 3Z1/33) yielded" + "; subbuffer4xi-yielded-by-create2subbuffer4xi: " + str(subbuffer4xi) + "; time: " + time4xi() + "}"
#       print4xi(class2print, method2print, message2print)                                                              
#
#">

# -------------------------------------------------------------------------------------------------   
def create2subbuffer4mpu(task4create2mpu=None):

    '''
    creates mpu2subbuffer4xi
    '''
    
    global mpu2subbuffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2subbuffer4mpu" 
    method2print = "create2subbuffer4mpu"

    message2print = "{(Step 1A/70) started" + "; create2subbuffer4mpu-started: " + str(create2subbuffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4create2mpu-to-create2subbuffer4mpu: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    mpu2subbuffer4xi = {}                                                                                        # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4create2mpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO MPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4create2mpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4create2mpu-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            function2callback4mpu = trace2subbuffer4mpu                                                       # CALLBACK FUNCTION FOR MPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4mpu-initialized-by-create2subbuffer4mpu to: " + str(function2callback4mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2subbuffer4mpu"                                                    # MODULE OF MPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2subbuffer4mpu"                                                    # FUNCTION OF MPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2subbuffer4mpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR MPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-initialized-by-create2subbuffer4mpu to: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '1E-'
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACK - EXTRA                      
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu['DATA2CALLBACK'] = args2callback                                                     # USER DATA PASSED TO MPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4create2mpu['FUNCTION2CALLBACK'] = function2callback4mpu                                      # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) set" + "; task4create2mpu-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                     
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-initialized-by-create2subbuffer4mpu to: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            try:
                platform2xi = get2platformids4xi()
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2subbuffer4mpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2subbuffer4mpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4create2mpu['PLATFORM'] = platform2xi                                                            # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - NEEDED TO CREATE BUFFER                      
            # ---------------------------------------------------------------------------------------------    
            context2mpu = None
            message2print = "{(Step 3A/70) trying" + "; context2mpu-trying-by-create2subbuffer4mpu: " + str(context2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2mpu = get2context4mpu()                                                               # NO PARAMETERS - THE SYSTEM CREATES   
                
                message2print = "{(Step 3B/70) got" + "; context2mpu-got-by-create2subbuffer4mpu: " + str(context2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # 
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2mpu-failed-by-create2subbuffer4mpu: " + str(context2mpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
            task4create2mpu ['CONTEXT'] = context2mpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - EXTRA                        
            # ---------------------------------------------------------------------------------------------    
            device2mpu = None
            message2print = "{(Step 4A/70) trying" + "; device2mpu-trying-by-create2subbuffer4mpu: " + str(device2mpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2mpu = get2mpu4xi()                                                                     # NO PARAMETERS - THE SYSTEM CREATES    
                
                message2print = "{(Step 4B/70) got" + "; device2mpu-got-by-create2subbuffer4mpu: " + str(device2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # 
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2mpu-failed-by-create2subbuffer4mpu: " + str(device2mpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4create2mpu ['DEVICE'] = device2mpu
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE FLAGS - NEEDED TO CREATE BUFFER                         
            # ---------------------------------------------------------------------------------------------         
            task4create2mpu ['FLAGS'] = 0b00000000000000000000000000000000
            message2print = "{(Step 6A/70) initialized" + "; flags-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu ['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2ack  = code2ack + '6A-'         
        
            # ---------------------------------------------------------------------------------------------
            # (7) DEFINE SIZE OF MEMORY OBJECT - NEEDED TO CREATE BUFFER                        
            # ---------------------------------------------------------------------------------------------         
            task4create2subbuffer ['SIZE'] = 8192*4
            message2print = "{(Step 7A/70) initialized" + "; size2subbuffer-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu ['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            code2ack  = code2ack + '7A-'
            
            # -----------------------------------------------------------------------------------------
            # (8) ARENA TO MPU - NEEDED TO CREATE BUFFER  
            # ----------------------------------------------------------------------------------------- 
            arena2mpu = None
            message2print = "{(Step 8A/70) try" + "; size2subbuffer-try-by-create2subbuffer4mpu: " + str(task4create2mpu ['SIZE']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            try:
                arena2mpu = Arena4Xi(task4create2subbuffer ['SIZE'])
                message2print = "{(Step 8B/70) created" + "; arena2mpu-initialized-by-create2subbuffer4mpu to: " + str(arena2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                
                code2ack  = code2ack + '8A-'             
            except:
                task4create2subbuffer ['SIZE'] = int(task4create2subbuffer ['SIZE']/4)                              # RE-ADJUST AND TRYGET LESS MEMORY
                
                message2print = "{(Step 8C/70) set" + "; size2subbuffer-set-by-create2subbuffer4mpu to: " + str(task4create2mpu ['SIZE'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                try:
                    arena2mpu = Arena4Xi(task4create2subbuffer ['SIZE'])
                    message2print = "{(Step 8D/70) created" + "; arena2mpu-initialized-by-create2subbuffer4mpu to: " + str(arena2mpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                
                    code2ack  = code2ack + '8D-'
                                          
                except:
                    message2print = "{(Step 8Z/70) failed" + "; arena2mpu-failed-by-create2subbuffer4mpu: " + str(arena2mpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 
                    code2nack  = code2nack + '8Z-' 
                   
            task4create2subbuffer ['POINTER2BUFFER'] = arena2mpu.buffer       
            
            message2print = "{(Step 8E/70) set" + "; buffer-set-by-create2subbuffer4mpu to: " + str(task4create2subbuffer ['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            code2ack  = code2ack + '8E-'
                            
            # ---------------------------------------------------------------------------------------------
            # (9) ERROR CODE - NEEDED TO CREATE BUFFER                      
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['CODE2ERROR'] = 0                                                                   # 
              
            message2print = "{(Step 9A/70) created" + "; code2error-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu ['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '9A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (10) REFERENCE COUNT - REQUIRED FOR RETAIN(ATTACH) AND RELEASE                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['COUNT2REFERENCE'] = 0                                                              # USED TO RETAIN(ATTACH) AND RELEASE BUFFER
              
            message2print = "{(Step 10A/70) created" + "; count2reference-initialized-by-create2subbuffer4mpu to: " + str(task4create2mpu ['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '10A-'
                                        
            # ---------------------------------------------------------------------------------------------
            # (11) BUFFER - NEEDED TO CREATE SUBBUFFER                  
            # ---------------------------------------------------------------------------------------------              
            buffer2mpu = None
            message2print = "{(Step 11Z/70) yielded" + "; buffer2mpu-yielded-by-create2subbuffer4mpu: " + str(buffer2mpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            
            try:
                buffer2mpu = create2buffer4mpu(task4create2mpu)                                            # CREATE BUFFER   
                
                message2print = "{(Step 11A/70) created" + "; buffer2mpu-initialized-by-create2subbuffer4mpu to: " + str(buffer2mpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                task4create2mpu ['BUFFER'] = buffer2mpu
                
                message2print = "{(Step 11A/70) set" + "; buffer2mpu-set-by-create2subbuffer4mpu to: " + str(task4create2mpu ['BUFFER'])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #
                code2ack  = code2ack + '11A-'                                                      
            except:
                message2print = "{(Step 11Z/70) yielded" + "; buffer2mpu-yielded-by-create2subbuffer4mpu: " + str(buffer2mpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                                        
            # ---------------------------------------------------------------------------------------------
            # (12) TYPE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['TYPE'] = 'REGION'                                                                  # TYPE 
              
            message2print = "{(Step 12A/70) set" + "; type-set-by-create2subbuffer4mpu to: " + str(task4create2mpu ['TYPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '12A-' 
                                                    
            # ---------------------------------------------------------------------------------------------
            # (13) OFFSET - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['OFFSET'] = 8192                                                                    # OFFSET TO BUFFER 
              
            message2print = "{(Step 13A/70) set" + "; offset-set-by-create2subbuffer4mpu to: " + str(task4create2mpu ['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '13A-' 
                                                    
            # ---------------------------------------------------------------------------------------------
            # (14) SIZE - REQUIRED                       
            # ---------------------------------------------------------------------------------------------              
            task4create2mpu ['SIZE'] = int(buffer2mpu['SIZE'] / 8)                                            # REGION SIZE
              
            message2print = "{(Step 14A/70) set" + "; offset-set-by-create2subbuffer4mpu to: " + str(task4create2mpu ['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '14A-'       
      
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4create2mpu-yielded-by-create2subbuffer4mpu: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        code2nack  = code2nack + '1Z1-' 

    mpu2subbuffer4xi = {}                                                                                        # INITIALIZE MPU BUFFER                                                                                     

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4create2mpu.keys()        
    message2print = "{(Step 8/70) using" + "; keys2task-using-by-create2subbuffer4mpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 

    if 'DATA2CALLBACK' in keys2task:
                                                                                                                        
        message2print = "{(Step 11A/70) try" + "; data2callback-try-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 11/70) - DATA2CALLBACK - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['DATA2CALLBACK'] = task4create2mpu['DATA2CALLBACK']
            
            message2print = "{(Step 11B/70) initialized" + "; data2callback-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '11B-'
        except: 
            message2print = "{(Step 11Z1/70) yielded" + "; data2callback-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '11Z1-'

    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 12A/70) try" + "; function2callback-try-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 12/70) - FUNCTION2CALLBACK - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['FUNCTION2CALLBACK'] = task4create2mpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 12B/70) initialized" + "; function2callback-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '12B-'
        except: 
            message2print = "{(Step 12Z1/70) yielded" + "; function2callback-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '12Z1-' 
               

    if 'CONTEXT' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 13/70) - CONTEXT - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['CONTEXT'] = task4create2mpu['CONTEXT']
            
            message2print = "{(Step 13B/70) initialized" + "; context-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '13B-'
        except: 
            message2print = "{(Step 13Z1/70) yielded" + "; context-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '13Z1-' 

    if 'DEVICE' in keys2task:    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 14/70) - DEVICE - EXTRA FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['DEVICE'] = task4create2mpu['DEVICE']
            
            message2print = "{(Step 14B/70) initialized" + "; device-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '14B-'
        except: 
            message2print = "{(Step 14Z1/70) yielded" + "; device-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '14Z1-'         

    if 'FLAGS' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 15/70) - FLAGS - REQUIRED FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['FLAGS'] = task4create2mpu ['FLAGS'] 
            
            message2print = "{(Step 15B/70) initialized" + "; flags-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['FLAGS'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '15B-'
        except: 
            message2print = "{(Step 15Z1/70) yielded" + "; flags-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '15Z1-'     
    

    if 'SIZE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 16/70) - SIZE - REQUIRED FOR REGION
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['SIZE'] = task4create2mpu ['SIZE'] 
            
            message2print = "{(Step 16B/70) initialized" + "; size-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['SIZE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '16B-'
        except: 
            message2print = "{(Step 16Z1/70) yielded" + "; size-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '16Z1-'             

    if 'POINTER2BUFFER' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 17/70) - POINTER2BUFFER - EXTRA - MIGHT BE USEFUL TO CALCULATE
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['POINTER2BUFFER'] = task4create2mpu ['POINTER2BUFFER'] 
            
            message2print = "{(Step 17B/70) initialized" + "; pointer2subbuffer-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['POINTER2BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '17B-'
        except: 
            message2print = "{(Step 17Z1/70) yielded" + "; pointer2subbuffer-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '17Z1-'    

    if 'CODE2ERROR' in keys2task:             
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 18/70) - ERROR CODE - REQUIRED FOR SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['CODE2ERROR'] = task4create2mpu['CODE2ERROR']
            
            message2print = "{(Step 18B/70) initialized" + "; code2error-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '18B-'
        except: 
            message2print = "{(Step 18Z1/70) yielded" + "; code2error-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '18Z1-'                

    if 'COUNT2REFERENCE' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 19/70) - REFERENCE COUNT - MUST FOR MANAGEMENT SUB-BUFFER
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['COUNT2REFERENCE'] = task4create2mpu['COUNT2REFERENCE']
            
            message2print = "{(Step 19B/70) initialized" + "; reference-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '19B-'
        except: 
            message2print = "{(Step 19Z1/70) yielded" + "; reference-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '19Z1-'                     

    if 'BUFFER' in keys2task:                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 20/70) - BUFFER - REQUIRED TO TAKE FROM
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['BUFFER'] = task4create2mpu['BUFFER']
            
            message2print = "{(Step 20B/70) initialized" + "; buffer-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '20B-'
        except: 
            message2print = "{(Step 20Z/70) yielded" + "; buffer-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '20Z-' 

    if 'TYPE' in keys2task:                         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21/70) - TYPE - REQUIRED - REGION
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['TYPE'] = task4create2mpu['TYPE']
            
            message2print = "{(Step 21B/70) initialized" + "; type-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['TYPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '21B-'
        except: 
            message2print = "{(Step 21Z/70) yielded" + "; type-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z-' 

    if 'OFFSET' in keys2task:                                      
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22/70) - OFFSET - REQUIRED FOR REGION
            # -----------------------------------------------------------------------------------------               
            mpu2subbuffer4xi['OFFSET'] = 8192
            
            message2print = "{(Step 22B/70) initialized" + "; offset-initialized-by-create2subbuffer4mpu to: " + str(mpu2subbuffer4xi['OFFSET'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            code2ack  = code2ack + '22B-'
        except: 
            message2print = "{(Step 22Z/70) yielded" + "; offset-mpu2subbuffer4xi-yielded-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z-'           

    if 'COUNT2REFERENCE' in keys2task:
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - ADD REFERENCE COUNT TO BUFFER DUE TO NEW SUB-BUFFER ADDED TO IT               
            # -----------------------------------------------------------------------------------------    
            task4retain2mpu = {}
            task4retain2mpu ['COUNT2REFERENCE'] = 1                                                              # REFERENCE COUNT
    
            response4retain2mpu = {}
                              
            response4retain2mpu = retain2buffer4mpu(task4retain2mpu)                                       # COUNT2REFERENCE                                                      
            
            message2print = "{(Step 22B/70) added" + "; referencecount-added-by-create2subbuffer4mpu: " + str(response4retain2mpu) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)
            # 
            
            code2ack  = code2ack + '22B-'
        except:
            message2print = "{(Step 23Z/70) yielded" + "; referencecount-yielded-by-create2subbuffer4mpu: " + str(response4retain2mpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
            
            code2nack  = code2nack + '22Z-' 
                                                                           
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    mpu2subbuffer4xi ['ACK2RETURN']  = code2ack
    mpu2subbuffer4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; mpu2subbuffer4xi-returning-by-create2subbuffer4mpu: " + str(mpu2subbuffer4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'BUFFER': {'POINTER2BUFFER': <mmap.mmap object at 0x0000000004903138>,
    #  'ACK2RETURN': ' ',
    #  'COUNT2REFERENCE': 1,
    #  'NACK2RETURN': ' 1Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792},
    #  'POINTER2BUFFER': <mmap.mmap object at 0x0000000004903138>, 'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 00:14:43 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000032BAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'OFFSET': 8192, 'NACK2RETURN': ' 11Z1-12Z1-14Z1-', 'ACK2RETURN': ' 13B-15B-16B-17B-18B-19B-20B-21B-22B-22B-',
    #  'TYPE': 'REGION', 'SIZE': 4224}; time: 00:14:44 09/02/11 Pacific Daylight Time}

    
    return mpu2subbuffer4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2buffer4mpu" usage = "
#
#    # Example (from buffer4xi.py - task4set2mpu got as parameter - see buffer4xi5test.py)
#
#    if buffer4xi is None:
#        buffer4xi = create2buffer4xi()                                                                            # CREATE COMMANDQUEUE4XI
#    try:
#        # -----------------------------------------------------------------------------
#        # (Step 4A/33)
#        # ----------------------------------------------------------------------------- 
#        message2print = "{(Step 4A/33) passing" + "; task-passing-to-set2buffer4mpu: " + str(task4set2mpu['MPU'])  + "; time: " + time4xi() + "}"  
#        print4xi(class2print, method2print, message2print)                                                         
#        
#        buffer4xi ['MPU'] = set2buffer4mpu(task4set2mpu['MPU'])                                           # 
#          
#        message2print = "{(Step 4B/33) set" + "; mpu-buffer-set-by-set2buffer4mpu to: " + str(buffer4xi ['MPU'])  + "; time: " + time4xi() + "}"
#        print4xi(class2print, method2print, message2print)                                                          
#        code2ack  = code2ack + '4B-'
#   except:
#        message2print = "{(Step 4Z1/33) yielded" + "; mpu-yielded-by-set2buffer4xi: " + 'MPU' + "; time: " + time4xi() + "}"
#        print4xi(class2print, method2print, message2print) 
#        code2nack  = code2nack + '4Z1-'
#">

# -------------------------------------------------------------------------------------------------   
def set2buffer4mpu(task4set2mpu=None):

    '''
    sets mpu2buffer4xi
    '''

    global mpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2buffer4mpu"
    method2print = "set2buffer4mpu"

    message2print = "{(Step 1A/33) started" + "; set2buffer4mpu-started: " + str(set2buffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4set2mpu-to-set2buffer4mpu: " + str(task4set2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if mpu2buffer4xi is None:
            mpu2buffer4xi = create2buffer4mpu()                                                               # INITIALIZE BUFFER FOR MPU                      
    except:
        try:
            mpu2buffer4xi = create2buffer4mpu()
        except:
            mpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 9A/70) try" + "; data2callback-try-by-set2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 2/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['DATA2CALLBACK'] = task4set2mpu['DATA2CALLBACK']
        
        message2print = "{(Step 9B/70) initialized" + "; data2callback-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '9B-'
    except: 
        message2print = "{(Step 9Z1/70) yielded" + "; data2callback-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '9Z1-'
    
    message2print = "{(Step 10A/70) try" + "; function2callback-try-by-set2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 10/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['FUNCTION2CALLBACK'] = task4set2mpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 10B/70) initialized" + "; function2callback-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '10B-'
    except: 
        message2print = "{(Step 10Z1/70) yielded" + "; function2callback-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '10Z1-' 
           
    message2print = "{(Step 11A/70) try" + "; info2private-try-by-set2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11/70) - INFO2PRIVATE - EXTRA
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['INFO2PRIVATE'] = task4set2mpu['INFO2PRIVATE']
        
        message2print = "{(Step 11B/70) initialized" + "; info2private-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['INFO2PRIVATE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '11B-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; info2private-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-'             
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12/70) - CONTEXT
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['CONTEXT'] = task4set2mpu['CONTEXT']
        
        message2print = "{(Step 12B/70) initialized" + "; context-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '12B-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; context-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13/70) - DEVICE
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['DEVICE'] = task4set2mpu['DEVICE']
        
        message2print = "{(Step 13B/70) initialized" + "; device-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '13B-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; device-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-'         

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14/70) - PROPERTIES (EXECUTION and PROFILING)
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['PROPERTIES'] = task4set2mpu['PROPERTIES']
        
        message2print = "{(Step 14B/70) initialized" + "; properties-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['PROPERTIES'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '14B-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; properties-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'     

    try:
        # -----------------------------------------------------------------------------------------
        # (Step 15/70) - ERROR CODE
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['CODE2ERROR'] = task4set2mpu['CODE2ERROR']
        
        message2print = "{(Step 15B/70) initialized" + "; code2error-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '15B-'
    except: 
        message2print = "{(Step 15Z1/70) yielded" + "; code2error-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '15Z1-'                
                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 16/70) - REFERENCE COUNT
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['COUNT2REFERENCE'] = task4set2mpu['COUNT2REFERENCE']
        
        message2print = "{(Step 16B/70) initialized" + "; reference-initialized-by-set2buffer4mpu to: " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack  = code2ack + '16B-'
    except: 
        message2print = "{(Step 16Z1/70) yielded" + "; reference-mpu2buffer4xi-yielded-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '16Z1-'                     
            
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    mpu2buffer4xi ['ACK2RETURN']  = code2ack
    mpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; mpu2buffer4xi-returning-by-set2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0,
    #  'COUNT2REFERENCE': 0,
    #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4mpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2buffer4mpu',
    #  'METHOD': 'create2buffer4mpu'},
    #  'FUNCTION2CALLBACK': <function trace2buffer4mpu at 0x0000000003F432C8>,
    #  'POINTER2BUFFER': <mmap.mmap object at 0x000000000434BFA8>,
    #  'FLAGS': 0,
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 01:27:58 09/02/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000032CAB48>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318,
    #  'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2,
    #  'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
    #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write',
    #  'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536,
    #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
    #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK',
    #  'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
    #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
    #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
    #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
    #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_MPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'NACK2RETURN': ' 9Z1-10Z1-11Z1-14Z1-15Z1-16Z1-', 'ACK2RETURN': ' 12B-13B-', 'SIZE': 278528}; time: 01:27:58 09/02/11 Pacific Daylight Time}


    return mpu2buffer4xi

            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2buffer4mpu" usage = "
#
#   # Example (see buffer4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RELEASED BY DECRENTING COUNT WITH 1             
#   task4release2buffer = {}
#   task4release2buffer ['MPU'] = {} 
#    
#   task4release2buffer ['MPU'] ['COUNT2REFERENCE'] = 1                                                          # REFERENCE COUNT
#   response4release2buffer = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RELEASE BUFFEROF MPU DEVICE ', time4xi())  
#   try:                               
#       response4release2buffer = release2buffer4xi(task4release2buffer)                                            # COUNT2REFERENCE                                                      
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RELEASE2BUFFER: ', response4release2buffer)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RELEASE BUFFEROF MPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def release2buffer4mpu(task4release2mpu=None):

    '''
    releases mpu2buffer4xi
    '''
    
    global mpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2buffer4mpu"
    method2print = "release2buffer4mpu" 

    message2print = "{(Step 1A/33) started" + "; release2buffer4mpu-started: " + str(release2buffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # 
    
    message2print = "{(Step 1B/33) passed" + "; task4release2mpu-to-release2buffer4mpu: " + str(task4release2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if mpu2buffer4xi is None:
            mpu2buffer4xi = create2buffer4mpu()                                                               # INITIALIZE BUFFER                
    except:
        try:
            mpu2buffer4xi = create2buffer4mpu()
        except:
            mpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; mpu2buffer4xi-yielded-by-release2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2mpu is None:
        task4release2mpu = {}
        task4release2mpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        mpu2buffer4xi['COUNT2REFERENCE'] = mpu2buffer4xi['COUNT2REFERENCE'] - task4release2mpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2buffer4mpu: " + str(mpu2buffer4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
         
        if mpu2buffer4xi['COUNT2REFERENCE'] < 0:
            mpu2buffer4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2buffer4mpu: " + " ** " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
                
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            mpu2buffer4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2buffer4mpu: " + " ** " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; mpu2buffer4xi-yielded-by-release2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    mpu2buffer4xi ['ACK2RETURN']  = code2ack
    mpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; mpu2buffer4xi-returning-by-release2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'ACK2RETURN': ' ', 'NACK2RETURN': ' 8Z1-',
    #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 04:38:48 05/21/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x000000000357E448>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568',
    #  'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472,
    #  'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK',
    #  'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE4CONSTANT': 65536,
    #  'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
    #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
    #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768,
    #  'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
    #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-',
    #  'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global',
    #  'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
    #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK',
    #  'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64,
    #  'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
    #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little',
    #  'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_MPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
    #  'PROPERTIES': None}; time: 04:38:48 05/21/11 Pacific Daylight Time}
 
    
    return mpu2buffer4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2buffer4mpu" usage = "
#
#   # Example (see buffer4xi5test.py)
#   # (19) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAIND BY INCREMENTING COUNT WITH 1             
#   task4retain2buffer = {}
#   task4retain2buffer ['MPU'] = {} 
#    
#   task4retain2buffer ['MPU'] ['COUNT2REFERENCE'] = 1                  # ADD REFERENCE COUNT BY 1
#   response4retain2buffer = {}
#   
#   print('(Step 5A/33) OF COMMANDQUEUE4XI5TEST - TRYING TO RETAIN BUFFEROF MPU DEVICE ', time4xi())  
#   try:                               
#       response4retain2buffer = retain2buffer4xi(task4retain2buffer)                                                                                          
#       print('(Step 5BD/33) OF COMMANDQUEUE4XI5TEST - RESPONSE4RETAIN2BUFFER: ', response4retain2buffer)                          
#       
#   except:
#       print('(Step 5Z1/33) OF COMMANDQUEUE4XI5TEST *** FAILED TO RETAIN BUFFEROF MPU DEVICE ', time4xi())  
#">

# -------------------------------------------------------------------------------------------------   
def retain2buffer4mpu(task4retain2mpu=None):

    '''
    retains mpu2buffer4xi
    '''
    global mpu2buffer4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2buffer4mpu"
    method2print = "retain2buffer4mpu"

    message2print = "{(Step 1A/33) started" + "; retain2buffer4mpu-started: " + str(retain2buffer4mpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              #  
    # <function retain2buffer4mpu at 0x000000000392F448> 
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2mpu-to-retain2buffer4mpu: " + str(task4retain2mpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # {'COUNT2REFERENCE': 1}

             
    code2ack  = ' '
    code2nack = ' '

    try:
        if mpu2buffer4xi is None:
            mpu2buffer4xi = create2buffer4mpu()                                                               # INITIALIZE BUFFER                
    except:
        try:
            mpu2buffer4xi = create2buffer4mpu()
        except:
            mpu2buffer4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; mpu2buffer4xi-yielded-by-retain2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; retain-try-by-retain2buffer4mpu: " + str(mpu2buffer4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003FB36A0>, 
    #      'ACK2RETURN': ' 13B-15B-16B-17B-', 
    #     'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-', 
    #       'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4mpu-failed ; time: 00:44:53 05/25/11 Pacific Daylight Time}',
    #  'CLASS': 'create2context4mpu', 'METHOD': 'create2context4mpu'}, 'FUNCTION2CALLBACK': <function trace2context4mpu at 0x00000000038D36C8>,
    #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None,
    #  'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
    #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
    #         'FLAGS': 0, 
    #          'SIZE': 33792
    # }; time: 00:44:54 05/25/11 Pacific Daylight Time}
       
    try:
        # -----------------------------------------------------------------------------------------
        # RETAIN  
        # -----------------------------------------------------------------------------------------               
        message2print = "{(Step 1B1/70) using" + "; current2reference-using-by-retain2buffer4mpu: " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0
        
        message2print = "{(Step 1B2/70) using" + "; add2reference-using-by-retain2buffer4mpu: " + str(task4retain2mpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 1
        
        mpu2buffer4xi['COUNT2REFERENCE'] = int(mpu2buffer4xi['COUNT2REFERENCE']) + int(task4retain2mpu['COUNT2REFERENCE'])
        
        message2print = "{(Step 1C/70) calculated" + "; count2reference-calculated-by-retain2buffer4mpu: " + str(mpu2buffer4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
         
        if mpu2buffer4xi['COUNT2REFERENCE'] <= 0:
            mpu2buffer4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1D/70) warning" + "; count2reference-warning-by-retain2buffer4mpu: " + " ** " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
                
            code2nack  = code2nack + '1D-'
        else:
            code2ack  = code2ack + '1D-'
        #
    except:
        try:
            mpu2buffer4xi['COUNT2REFERENCE'] = 1
            
            message2print = "{(Step 1Z1/70) warning" + "; count2reference-warning-by-retain2buffer4mpu: " + " ** " + str(mpu2buffer4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '1Z1-'
            
        except:
            message2print = "{(Step 1Z2/70) yielded" + "; mpu2buffer4xi-yielded-by-retain2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)            
    # -----------------------------------------------------------------------------------------
    mpu2buffer4xi ['ACK2RETURN']  = code2ack
    mpu2buffer4xi ['NACK2RETURN'] = code2nack 
    
    message2print = "{(Step 70/70) returning" + "; mpu2buffer4xi-returning-by-retain2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    return mpu2buffer4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2bufferinfo4mpu" usage = "
#
#   try:                               
#       response4get2mpu = get2bufferinfo4mpu()                                        
#                                                                                                                   
#   except:
#       ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2bufferinfo4mpu():

    '''
    gets mpu2buffer4xi
    '''
    
    global mpu2buffer4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2bufferinfo4mpu"
    method2print = "get2bufferinfo4mpu"

    message2print = "{(Step 1A/33) started" + "; get2bufferinfo4mpu-started: " + str(get2bufferinfo4mpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                                                               
    try: 
        if mpu2buffer4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            mpu2xi = create2buffer4mpu()
            message2print = "{(Step 1B/33) initialized" + "; mpu2xi-initialized-by-get2bufferinfo4mpu to: " + str(mpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                
        else:
            # -------------------------------------------------------------------------------------
            # RETURN THE EXISTING BUFFER FOR MPU          
            # -------------------------------------------------------------------------------------     
            mpu2xi = mpu2buffer4xi
            message2print = "{(Step 1C/33) got" + "; mpu2xi-got-by-get2bufferinfo4mpu: " + str(mpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE           
            # -------------------------------------------------------------------------------------           
            mpu2xi = create2buffer4mpu()
            message2print = "{(Step 1D/33) initialized" + "; mpu2xi-initialized-by-get2bufferinfo4mpu to: " + str(mpu2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                        
        except:
            mpu2xi = None
            message2print = "{(Step 1Z2/70) yielded" + "; mpu2buffer4xi-yielded-by-get2buffer4mpu: " + str(mpu2buffer4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                        
    message2print = "{(Step 33/33) returning" + "; mpu2xi-returning-by-get2bufferinfo4mpu: " + str(mpu2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    #  
    
    return mpu2xi
            
#</function4xi> 
 
                                               
# =================================================================================================
#<class4xi class = "MPU2Buffer4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for MPU buffer" usage = "Buffer4Xi of MPU"
#>

# =================================================================================================
class MPU2Buffer4Xi(object): 
    ''' 
    MPU2Buffer4Xi offers  methods for MPU buffer
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2mpu = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'create2mpu',
    'get2mpu',
    'release2mpu',
    'retain2mpu',
    'set2mpu',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MPU2Buffer4Xi" usage = "
    # try:
    #     # ---------------------------------------------------------------------------------------------
    #     # CREATE OBJECT                        
    #     # ---------------------------------------------------------------------------------------------        
    #     cc2xi = MPU2Buffer4Xi()
    #     print('(Step 5B/33) OF MPU4XI5TEST - CREATED MPU2Buffer4Xi OBJECT: ', cc2xi)                                       
    # except:
    #     print('(Step 5Z/33) OF MPU4XI5TEST *** FAILED TO CREATE MPU2Buffer4Xi OBJECT')
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4create2mpu = None):
        '''
        _init__ method initializes MPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "MPU2Buffer4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 

        message2print = "{(Step 1B/33) borning" + "; mpu2buffer2xi-of-MPU2Buffer4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-mpu2buffer2xi-of-MPU2Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #   
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2mpu-sharing-by-mpu2buffer2xi-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi.classvariable2mpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                
                                
        message2print = "{(Step 1E/33) passed" + "; task4create2mpu-passed-to-init-of-MPU2Buffer4Xi: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #                               
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) passing" + "; task4create2mpu-passing-to-create2buffer4mpu-by-init-of-MPU2Buffer4Xi: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
        
        mpu2buffer2xi = create2buffer4mpu(task4create2mpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2buffer4mpu-performed-by-init-of-MPU2Buffer4Xi: " + str(create2buffer4mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #  
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; mpu2buffer2xi-of-MPU2Buffer4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-mpu2buffer2xi-of-MPU2Buffer4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2mpu-shared-by-mpu2buffer2xi-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi.classvariable2mpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          #               
       
        message2print = "{(Step 3D/33) returning" + "; init-of-MPU2Buffer4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create-of-MPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF MPU2COMMANDQUEUE4XI - TRYING TO CREATE MPU COMMANDQUEUE')
    # try:
    #     cc2xi = MPU2Buffer4Xi()                            
    #     buffer2mpu = cc2xi.create2mpu()                                  
    #     print('(Step 1B/33) OF MPU4XI5TEST - SET MPU COMMANDQUEUE: ', buffer2mpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF MPU4XI5TEST *** FAILED TO SET MPU BUFFER***')
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2mpu(self, task4create2mpu = None):
        '''
        create2mpu method creates objects of MPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "MPU2Buffer4Xi"
        method2print = "create2mpu"
                     
        message2print = "{(Step 1A/33) started" + "; create2mpu-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4create2mpu-passed-to-create2mpu-of-MPU2Buffer4Xi: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4create2mpu-passing-to-create2buffer4mpu-by-create2mpu-of-MPU2Buffer4Xi: " + str(task4create2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        mpu2buffer2xi = create2buffer4mpu(task4create2mpu)

        message2print = "{(Step 2B/33) performed" + "; create2buffer4mpu-performed-by-create2mpu-of-MPU2Buffer4Xi: " + str(create2buffer4mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; mpu2buffer2xi-returning-by-create2mpu-of-MPU2Buffer4Xi: " + str(mpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
 
                
        return mpu2buffer2xi
                                
    #                        
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2mpu-of-MPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF MPU2COMMANDQUEUE4XI - TRYING TO SET MPU COMMANDQUEUE')
    # try:
    #     cc2xi = MPU2Buffer4Xi()                            
    #     buffer2mpu = cc2xi.set2mpu()                                  
    #     print('(Step 1B/33) OF MPU4XI5TEST - SET MPU COMMANDQUEUE: ', buffer2mpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF MPU4XI5TEST *** FAILED TO SET MPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2mpu(self, task4set2mpu = None):
        '''
        sets MPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "MPU2Buffer4Xi"
        method2print = "set2mpu"
                     
        message2print = "{(Step 1A/33) started" + "; set2mpu-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4set2mpu-passed-to-set2mpu-of-MPU2Buffer4Xi: " + str(task4set2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2mpu-passing-to-set2buffer4mpu-by-set2mpu-of-MPU2Buffer4Xi: " + str(task4set2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        mpu2buffer2xi = set2buffer4mpu(task4set2mpu)

        message2print = "{(Step 2B/33) performed" + "; set2buffer4mpu-performed-by-set2mpu-of-MPU2Buffer4Xi: " + str(set2buffer4mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; mpu2buffer2xi-returning-by-set2mpu-of-MPU2Buffer4Xi: " + str(mpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return mpu2buffer2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2mpu-of-MPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF MPU2COMMANDQUEUE4XI - TRYING TO GET MPU COMMANDQUEUE')
    # try:
    #     cc2xi = MPU2Buffer4Xi()                            
    #     buffer2mpu = cc2xi.get2mpu()                                  
    #     print('(Step 1B/33) OF MPU4XI5TEST - GOT MPU COMMANDQUEUE: ', buffer2mpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF MPU4XI5TEST *** FAILED TO GET MPU BUFFER***')   
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2mpu(self):
        '''
        get2mpu method gets objects of MPU2Buffer4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "MPU2Buffer4Xi"
        method2print = "get2mpu"
                     
        message2print = "{(Step 1A/33) started" + "; get2mpu-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        mpu2buffer2xi = get2bufferinfo4mpu()
        
        message2print = "{(Step 2A/33) returning" + "; mpu2buffer2xi-returning-by-get2mpu-of-MPU2Buffer4Xi: " + str(mpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
                
        return mpu2buffer2xi
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2mpu-of-MPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF MPU2COMMANDQUEUE4XI - TRYING TO SET MPU COMMANDQUEUE')
    # try:
    #     cc2xi = MPU2Buffer4Xi()                            
    #     buffer2mpu = cc2xi.release2mpu()                                  
    #     print('(Step 1B/33) OF MPU4XI5TEST - SET MPU COMMANDQUEUE: ', buffer2mpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF MPU4XI5TEST *** FAILED TO SET MPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2mpu(self, task4release2mpu = None):
        '''
        releases MPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "MPU2Buffer4Xi"
        method2print = "release2mpu"
                     
        message2print = "{(Step 1A/33) started" + "; release2mpu-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4release2mpu-passed-to-release2mpu-of-MPU2Buffer4Xi: " + str(task4release2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2mpu-passing-to-release2buffer4mpu-by-release2mpu-of-MPU2Buffer4Xi: " + str(task4release2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        mpu2buffer2xi = release2buffer4mpu(task4release2mpu)

        message2print = "{(Step 2B/33) performed" + "; release2buffer4mpu-performed-by-release2mpu-of-MPU2Buffer4Xi: " + str(release2buffer4mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; mpu2buffer2xi-returning-by-release2mpu-of-MPU2Buffer4Xi: " + str(mpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return mpu2buffer2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2mpu-of-MPU2Buffer4Xi" usage = "
    # print('(Step 1A/33) OF MPU2COMMANDQUEUE4XI - TRYING TO SET MPU COMMANDQUEUE')
    # try:
    #     cc2xi = MPU2Buffer4Xi()                            
    #     buffer2mpu = cc2xi.retain2mpu()                                  
    #     print('(Step 1B/33) OF MPU4XI5TEST - SET MPU COMMANDQUEUE: ', buffer2mpu)                                                  
    # except:
    #     print('(Step 1Z/33) OF MPU4XI5TEST *** FAILED TO SET MPU BUFFER***')  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2mpu(self, task4retain2mpu = None):
        '''
        retains MPU2Buffer4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "MPU2Buffer4Xi"
        method2print = "retain2mpu"
                     
        message2print = "{(Step 1A/33) started" + "; retain2mpu-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1B/33) passed" + "; task4retain2mpu-passed-to-retain2mpu-of-MPU2Buffer4Xi: " + str(task4retain2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain2mpu-passing-to-retain2buffer4mpu-by-retain2mpu-of-MPU2Buffer4Xi: " + str(task4retain2mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        mpu2buffer2xi = retain2buffer4mpu(task4retain2mpu)

        message2print = "{(Step 2B/33) performed" + "; retain2buffer4mpu-performed-by-retain2mpu-of-MPU2Buffer4Xi: " + str(retain2buffer4mpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; mpu2buffer2xi-returning-by-retain2mpu-of-MPU2Buffer4Xi: " + str(mpu2buffer2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #                                         
                
        return mpu2buffer2xi
                                                           
    #</methodize4xi>   
                                         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.sense())
    # 
    #     print('=' *33)          
    #     print('(Step 15B/33) OF MPU4XI5TEST - SENSED ', time4xi())                                                  
    #                                                                                                                 
    #     print('=' *33)
    # except:
    #     print('(Step 15Z/33) OF MPU4XI5TEST *** FAILED TO SENSE ', time4xi())    
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses MPU2Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'MPU2Buffer4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; MPU2Buffer4Xi-sensing-by-sense-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-MPU2Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2mpu-of-MPU2Buffer4Xi'] = MPU2Buffer4Xi.classvariable2mpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-MPU2Buffer4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; MPU2Buffer4Xi-sensed-by-sense-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-MPU2Buffer4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                    
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.reason())
    # 
    #     print('=' *33)          
    #     print('(Step 17B/33) OF MPU4XI5TEST - REASONED ', time4xi())                                                
    #     print('=' *33)       
    # except:
    #     print('(Step 17Z/33) OF MPU4XI5TEST *** FAILED TO REASON ', time4xi())     
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons MPU2Buffer4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'MPU2Buffer4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; MPU2Buffer4Xi-reasoning-by-reason-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-MPU2Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-MPU2Buffer4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-MPU2Buffer4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; MPU2Buffer4Xi-reasoned-by-reason-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-MPU2Buffer4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #                     
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MPU2Buffer4Xi" usage = "
    # try:
    #     print(cc2xi.ace())
    # 
    #     print('=' *33)          
    #     print('(Step 21B/33) OF MPU4XI5TEST - ACED ', time4xi())                                                    
    #     print('=' *33) 
    # except:
    #     print('(Step 21Z/33) OF MPU4XI5TEST *** FAILED TO ACE ', time4xi())      
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces MPU2Buffer4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'MPU2Buffer4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-MPU2Buffer4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; MPU2Buffer4Xi-acing-by-ace-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-MPU2Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-MPU2Buffer4Xi'] = MPU2Buffer4Xi.classvariable2mpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-MPU2Buffer4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; MPU2Buffer4Xi-aced-by-ace-of-MPU2Buffer4Xi: " + str(MPU2Buffer4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-MPU2Buffer4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                              
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   mpu3image4xi5test.txt
#   sense-mpu3image4xi5test.xml
#   reason-mpu3image4xi5test.xml
#   ace-mpu3image4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of mpu2buffer4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
